Integrating Wombat OAM with Cacti
=================================

Cacti
-----

[Cacti][] is an open-source web-based tool using [RRDTool][] as its backend for data storage and graphing.  It needs MySQL, net-snmp, PHP and a web server as further depedency.

[Cacti]: http://www.cacti.net/
[RRDTool]: http://www.rrdtool.org/

Installing Cacti
----------------

Most Linux distribution provide a Cacti package that can be installed along with the dependencies.

For Debian, the usual

```sh
sudo apt-get install cacti
```

guides one through the whole installation process: database setup user creation, etc.


Notes on VirtualBox installation
--------------------------------

In my configuration, Wombat is running directly on the OSX box, while Cacti is intalled into a VirtualBox VM.
In order to allow them to communicate, I used a _Host-only Adapter_ for the VM's network. This solution required further configuration in the global VirtualBox _Preferences_ dialog: the DHCP server for the virtual adapter had to be configured and enabled.

I've also set up a shared folder for easy transfer of the Wombat CLI script.
The script needs Python 3: get it by doing `sudo apt-get install python3`.


The `wombat_cli` script
----------------------

This script provides basic command-line access to the REST API of Wombat.

Sample session to discover nodes and metrics provided by them:

```
$ wombat_cli --host 33.33.33.1 --port 8080
This is Wombat, an operations and maintenance tool for Erlang systems
wombat 0.7.0
© 2012-2014, Erlang Solutions Ltd
Wombat@33.33.33.1> help

Documented commands (type help <topic>):
========================================
cacti_metrics  exit  get  help  list  metric  rawget  timequery

Wombat@33.33.33.1> help list
list [ nodes | alarms | families | node_metrics NODE-ID]
Wombat@33.33.33.1> list nodes
cookie          wo_test
deleted         False
domain_id       undefined
host            undefined
id              4f237968-8dbd-47b7-adbd-79ebbb9d2d20
name            wo_test@127.0.0.1
node_family_id  2968f6ef-7261-46d5-a240-ef939133801b
plugins_opts    []
state           UP
tref            undefined

Wombat@33.33.33.1> list node_metrics 4f237968-8dbd-47b7-adbd-79ebbb9d2d20
display  Total memory
name     total_memory
type     gauge
unit     byte

display  Atom memory
name     atom_memory
type     gauge
unit     byte

display  Binary memory
name     binary_memory
type     gauge
unit     byte

display  Code memory
name     code_memory
type     gauge
unit     byte

display  Number of DETS tables
name     dets_count
type     gauge
unit     numeric

. . . (over 100 such blocks here)

Wombat@33.33.33.1> exit
$
```

Example for outputting data in a format expected by Cacti:

```
$ wombat_cli --host 33.33.33.1 --port 8080 cacti_metrics 4f237968-8dbd-47b7-adbd-79ebbb9d2d20 total_memory binary_memory atom_memory cpu
total_memory: 49457840 binary_memory: 394296 atom_memory: 662409 cpu: 12 
$
```

Collecting data with Cacti
--------------------------

See also the [How to section of the Cacti documentation](http://www.cacti.net/downloads/docs/html/how_to.html).

### 1. Adding a new data input method

The first and the only Wombat-specific step of configuring Cacti: Select _Data Input Methods_ in the menu on the left of the Cacti web console, then click add and select _Script/Command_ as Input Type.

Cacti needs the exact path to the `wombat_cli` script, moreover it must be executable by the user running Cacti.
The command can be parametrised by using input fields in `<>`-brackets. The script output must either be a single value (numeric) or a space-separated list of `Key: Value` pairs.

Below is a fairly general setup for retrieving any single metric for a managed node from Wombat:

![Add new data input method](./cacti-input-method.png)

### 2. Create a new data template

This step is not strictly necessary, but speeds up adding new data sources later.

![Create a new data template](./cacti-data-template.png)

### 3. Adding data sources

![Adding data sources](./cacti-source.png)


### 4. More complex example -- collecting several metrics in one step

First, we'll need an input source with multiple fields:
![Multiple input](./cacti-memory-input.png)

Then a template:
![Memory data template](./cacti-memory-template.png)

Graph in Wombat:
![Wombat graph](./wombat-metrics-memory.png)

And in Cacti:
![Cacti graph](./cacti-metrics-memory.png)
