# -*- encoding: utf-8 -*-
#

"""
This is Wombat, an operations and maintenance tool for Erlang systems
© 2015, Erlang Solutions Ltd
"""

from datetime import timedelta, datetime

def timestr(d):
    """Format an UTC datetime object as YYYY-MM-DDTHH:MM:SS.MMMZ"""
    if d.utcoffset() != None:
        raise ValueError('bad datetime')
    if d.microsecond:
        return d.isoformat()[:-3] + "Z"
    else:
        return d.isoformat() + ".000Z"

def then_and_now(m):
    """Return a pair of formatted timestamps `(m minutes earlier, now)'
    for REST arguments"""
    now = datetime.utcnow()
    then = now - timedelta(minutes=m)
    return (timestr(then), timestr(now))
