Extracting ERTS
===============

Wombatn now includes the Erlang Runtime System (ERTS), which means it can
be started without installing erlang on the host machine, but it also means
that each distribution needs it's own release build.


If the Erlang version is updated the ERTS version needs updating as well.

Easiest way is to install an Erlang in the selected distribution in Docker and
extract the ERTS from that. It doesn't seem to be a big deal if the versions are a little different, for example 18.3 worked with the ERTS from 17.5 for a while, but let's keep it up to date.

Example:

Start the container:

```

docker pull centos:7 # to get the newest image
docker run -it -v $PWD:/current-dir centos:7 bash

```


```
> install erlang
Example:
https://www.unixmen.com/install-erlang-elixir-centos-7/
Verify that you have the correct version
Verify the version of your operating system, for example:
cat /etc/*release
```



Tar up the stuff:

```

tar -czvf centos7-erl-20.3.8.6-erts-9.3.3.3.tar.gz -C /usr/lib/erlang/ .
cp centos7-erl-20.3.8.6-erts-9.3.3.3.tar.gz /current-dir

```

Extract the tars into a directory, then create a new tar file called erlang-compat.tar.gz.

```
tar -czvf erlang-compat.tar.gz ./erlang-compat
```


Upload this tar.gz to AWS S3 bucket.

Fix paths in the rebar.config for the erts and system lib for each distro.




Example for centos, sometimetimes you get broken dependency errors:

```
yum update -y
yum install -y epel-release wget
wget http://packages.erlang-solutions.com/erlang-solutions-1.0-1.noarch.rpm
rpm -Uvh erlang-solutions-1.0-1.noarch.rpm
yum update -y
yum install erlang-20.3 # FAILS!!! workaround below:
wget https://packages.erlang-solutions.com/erlang/esl-erlang/FLAVOUR_1_general/esl-erlang_20.3.8.6-1~centos~6_amd64.rpm
yum install -y esl-erlang_20.3.8.6-1~centos~6_amd64.rpm

```