# How Wombat is built on Jenkins

On jenkins, building Wombat happens by invoking the `make docker_release` command.
This will start the Wombat Builder docker container and invoke some subtasks in the
Makefile.

First it builds Wombat for all the profiles we have, currently it's Debian and
OSX. This is necessary because they use different ERTS versions, and until now
rebar2 was regenerating a release on every install. We dropped this, and now
we ship multiple packages with ERTS and system libs included. This will hopefully
provide more stability.

The source of the builder container can be found in `scripts/jenkins/Dockerfile.jenkins-builder`.
The ERTS and System Libs get pulled from the AWS S3 `wombat-dev-public` bucket on
container build.

After this, it builds the plugins. Currently an erlang 14 container is used to build
most of the plugins. The plugins will get copied into the right directory
`rel/wombat/plugins` at packaging time. Elixir plugins get built with erlang 18.

Rebar3 can not really be configured to use different compilers for different files, 
so the compilation happens by manually calling `erlc`. The debug info should be 
encrypted in the beam files. The erlang14 container can be found in the above 
mentioned folder `Dockerfile.erlang14` file. The erlang18 compiler comes from 
the docker official images. The plugin compilers can be found in 
`scripts/build_erlang|elixir_agents.sh`.

The next step is building the tar files. It will call the `scipts/package_release.sh`
inside the same Wombat Builder jenkins container. This will copy the docs as well.
There is an argument you can use `-l` to skip copying artifacts
and docs.


## The issue with ERTS and System Libs

Until these changes Wombat was built with rebar2 and rebar2 included a generate
command which would regenerate all the start and boot scripts to include the
local ERTS paths and versions. This is no longer the case for rebar3. This is
why we have the `erlang-compat.tar` on S3, which should include a compatible
ERTS and System Libs for each OS we are building for. If you build the release
with one ERTS version, let's say 6.4 and you try to start it on ERTS 6.4.1 then
it will fail to start because it can not find the related ERTS version.

## Rebar3 config profiles

Separate profiles were created even for the debian build because the config
merging feature is pretty wonky.




