#!/bin/sh

# Return the version of the Erlang compiler in erlc.

if [ -z "$1" ]; then
    echo "Usage: $(basename $0) <path-to-erlc>"
    exit 1
fi

erlc=$1
script_dir=$(cd $(dirname "$0") >/dev/null && pwd -P)
tmpdir=$(mktemp -d -t wombat_erlc_compiler_version.XXXXXXXX)

dummy_erl="$script_dir/erlc_compiler_version_dummy_module.erl"
"$erlc" -o "$tmpdir" "$dummy_erl"
dummy_beam="$tmpdir/erlc_compiler_version_dummy_module.beam"

erlc_vsn=$("$script_dir/beam_compile_version_attribute" "$dummy_beam" || exit 1)

rm -rf "$tmpdir"

echo "$erlc_vsn"
