# Using the official AMI containing WombatOAM

We build AMIs from Wombat. Please get in touch at wombat@erlang-solutions.com if
you have no access to them.

When starting the Wombat AMI you should put the instance into a Security Group
which has the 80 and 443 ports open to be able to open the Web dashboard in your
browser.

Once  you have started the AMI, Wombat should be up and running. Try connecting
to the public IP of the instance in your browser. It will present a self-signed
certificate which is advised to be changed.

By default Wombat is started as `wombat@SHORT_HOSTNAME_OF_MACHINE`, for example
`wombat@ip-172-30-3-248`. You can use this hostname to add Wombat to itself by using
the cookie `wombat`.

You can check the status of Wombat by running:

```
[centos@ip-172-30-3-248 ~]$ sudo service wombat status
pong
Wombat is running: wombat@ip-172-30-3-248
```

You can find the password for the Wombat Web Dashboard in the `/home/centos/Wombat_README.md`
file.

If you want to change the Erlang Distribution Network Interface in Wombat, open
the `/etc/default/wombat` file and change the WOMBAT_NODENAME environment variable.
Please note that changing the node name will create an empty Wombat instance.
Use the command `sudo service wombat stop` before changing the node name.

If you can not add nodes to Wombat please check if TCP connections can be created
between the nodes, for further information check the section Configuration/Opening firewall ports.
You may have to configure EC2 Security Groups and iptables as well.

Make sure EPMD is not open to the world. It's advised to use a whole separate
network for communication between Erlang nodes.

All Wombat user data is saved to the directory `/wombat-data`.