System configuration REST interface
===================================

Get default values from sys.config
----------------------------------

Retrieve the current default values in the system configuration file.

### Definition

```
GET /api/system
```

### Example request

```
curl -X GET "http://127.0.0.1:8080/api/system"
```

### Example response

```json
{
  "enableOrch": true,
  "orchVersion": "v1",
  "enableTopoGraph": true,
  "enablePopupMessages": true,
  "enableForceSSL": false,
  "forceWebsocketSSL": false
}
```

### Example responses if licence expired

```json
{
  "enableOrch": true,
  "orchVersion": "v1",
  "enableTopoGraph": true,
  "enablePopupMessages": true,
  "enableForceSSL": false,
  "forceWebsocketSSL": false,
  "expiryInfo": "allowed_with_warning",
  "expiryText": "The license expired on 2015-12-31. WombatOAM will stop working"
                "after 2016-01-31. Please renew your license by contacting "
                "your Erlang Solutions sales representative or "
                "wombat@erlang-solutions.com."
}
```

### Arguments

None.

### Returns

An object with the current configuration settings.


Help/about REST interface
=========================

Get license text
----------------

Retrieve the WombatOAM licence text

### Definition

```
GET /api/help/about
```

### Example request

```
curl -X GET "http://127.0.0.1:8080/api/help/about"
```

### Example response

```json
{
  "text": "This is WombatOAM, an operations and maintenance tool for Erlang systems ...
}
```

### Arguments

None.

### Returns

The full WombatOAM licence text. Only the first line is shown in the example 
response.
