## Ecto plugin

### Description

The plugin gives insight into how Ecto performs. Its various metrics gives
fine-grain information about the operations carried out by Ecto. For each
operation type (e.g. SQL `SELECT` query) it measures the number of executed
operations and the average execution time. To provide a high level overview of
the operational status of Ecto, the plugin exposes 3 more metrics. The total
number of executed operations, the average time required to execute the
operations, and the average time while the operations were in the queue.

### Applications it depends on

`ecto`

The plugin works with all Ecto versions (latest 3.x).

### Modules

`wombat_plugin_ecto`

### Metrics reported

The three global metrics providing the high level overview:

- `Request`
  Tags: `dev`, `op`.

- `Request Avg ms`
  Tags: `dev`, `op`.

- `Queue Avg ms`
  Tags: `dev`, `op`.

And the fine-grain metrics for common operations:

- `OPERATION`
  Tags: `dev`.

- `OPERATION Avg ms`
  Tags: `dev`.

Where `OPERATION` is one of `SQL SELECT`, `SQL INSERT`, `SQL UPDATE`,
`SQL DELETE`, `SQL BEGIN`, `SQL COMMIT`, `SQL ROLLBACK`.
