## Elixir Logger plugin

### Description

The plugin subscribes to the Logger application running on the Elixir nodes that
are managed by WombatOAM. The plugin is capable of reporting all the logs as
notifications and the number of logs as metrics to WombatOAM. The differnt severity
levels of logs generated by Logger are `debug`, `info`, `warn` and `error` (in
ascending order of precedence). The default severity level is set to `warn`. So
the plugin reports only the logs and metrics for the `warn` and `error` severity
levels. The plugin also ignores Logger events originally form the `error_logger`
(as those are handled by another plugin).

### Application it depends on

`elixir`

### Modules

- `wombat_plugin_elixir_logger`
- `wombat_plugin_elixir_logger_handler`

### Reports

The plugin reports logs/notifications and the following metrics to WombatOAM.

- `Logger debug events`
  Tags: `dev`

- `Logger info events`
  Tags: `dev`

- `Logger warn events`
  Tags: `dev`, `op`

- `Logger error events`
  Tags: `dev`, `op`

These metrics show the number of log messages captured by the plugin on
different severity levels, at any given point in time. As the default
severity level is set to `warn`, the metrics for `info` and `debug` will
be shown as 0.

### Configuration options

* `report_metrics` (boolean, default: true): Specifies whether the WombatOAM server
  should receive the values for the above mentioned metrics.

#### Example wombat.config entry

```erlang
{set, wo_plugins, plugins, elixir_logger, report_metrics, true}.
```
