## emq plugin

### Description

The `EMQ` plugin reports various types of metrics from EMQ application. The plugin exposes counter and gauge metrics
which provide basic information of the server, load and statistical data of the clients.

### Applications it depends on

`emqx`

### Modules

`wombat_plugin_emq`

### Reports

#### Metrics reported

These metrics below are the basic ones, whenever a new plugin is loaded, additional metrics may appear.

**EMQ Byte metrics** category

- `sent`
  Tags: `dev`, `op`.
- `received`
  Tags: `dev`, `op`.

**EMQ Client metrics** category

- `connack`
  Tags: `dev`, `op`.
- `authenticate`
  Tags: `dev`, `op`.
- `auth.anonymous`
  Tags: `dev`, `op`.
- `connected`
  Tags: `dev`, `op`.
- `subscribe`
  Tags: `dev`, `op`.
- `connect`
  Tags: `dev`, `op`.
- `disconnected`
  Tags: `dev`, `op`.
- `check_acl`
  Tags: `dev`, `op`.
- `unsubscribe`
  Tags: `dev`, `op`.

**EMQ Delivery metrics** category

- `dropped`
  Tags: `dev`, `op`.
- `dropped.queue_full`
  Tags: `dev`, `op`.
- `dropped.too_large`
  Tags: `dev`, `op`.
- `dropped.qos0_msg`
  Tags: `dev`, `op`.
- `dropped.no_local`
  Tags: `dev`, `op`.
- `dropped.expired`
  Tags: `dev`, `op`.

**EMQ Messages metrics** category

- `retained`
  Tags: `dev`, `op`.
- `dropped.expired`
  Tags: `dev`, `op`.
- `dropped.no_subscribers`
  Tags: `dev`, `op`.
- `qos1.sent`
  Tags: `dev`, `op`.
- `forward`
  Tags: `dev`, `op`.
- `acked`
  Tags: `dev`, `op`.
- `delayed`
  Tags: `dev`, `op`.
- `qos0.sent`
  Tags: `dev`, `op`.
- `delivered`
  Tags: `dev`, `op`.
- `qos0.received`
  Tags: `dev`, `op`.
- `sent`
  Tags: `dev`, `op`.
- `qos2.received`
  Tags: `dev`, `op`.
- `dropped`
  Tags: `dev`, `op`.
- `received`
  Tags: `dev`, `op`.
- `publish`
  Tags: `dev`, `op`.
- `qos1.received`
  Tags: `dev`, `op`.
- `qos2.sent`
  Tags: `dev`, `op`.

**EMQ Packages metrics** category

- `publish.dropped`
  Tags: `dev`, `op`.
- `sent`
  Tags: `dev`, `op`.
- `publish.received`
  Tags: `dev`, `op`.
- `publish.sent`
  Tags: `dev`, `op`.
- `publish.inuse`
  Tags: `dev`, `op`.
- `pingresp.sent`
  Tags: `dev`, `op`.
- `puback.inuse`
  Tags: `dev`, `op`.
- `subscribe.auth_error`
  Tags: `dev`, `op`.
- `suback.sent`
  Tags: `dev`, `op`.
- `pubrel.sent`
  Tags: `dev`, `op`.
- `pubcomp.received`
  Tags: `dev`, `op`.
- `unsuback.sent`
  Tags: `dev`, `op`.
- `pubrel.received`
  Tags: `dev`, `op`.
- `disconnect.sent`
  Tags: `dev`, `op`.
- `connack.sent`
  Tags: `dev`, `op`.
- `puback.received`
  Tags: `dev`, `op`.
- `pubcomp.sent`
  Tags: `dev`, `op`.
- `unsubscribe.error`
  Tags: `dev`, `op`.
- `unsubscribe.received`
  Tags: `dev`, `op`.
- `pubrec.inuse`
  Tags: `dev`, `op`.
- `connack.auth_error`
  Tags: `dev`, `op`.
- `puback.sent`
  Tags: `dev`, `op`.
- `pubrel.missed`
  Tags: `dev`, `op`.
- `publish.error`
  Tags: `dev`, `op`.
- `publish.auth_error`
  Tags: `dev`, `op`.
- `pubrec.missed`
  Tags: `dev`, `op`.
- `auth.sent`
  Tags: `dev`, `op`.
- `pingreq.received`
  Tags: `dev`, `op`.
- `connect.received`
  Tags: `dev`, `op`.
- `auth.received`
  Tags: `dev`, `op`.
- `pubcomp.inuse`
  Tags: `dev`, `op`.
- `connack.error`
  Tags: `dev`, `op`.
- `pubrec.sent`
  Tags: `dev`, `op`.
- `received`
  Tags: `dev`, `op`.
- `pubrec.received`
  Tags: `dev`, `op`.
- `pubcomp.missed`
  Tags: `dev`, `op`.
- `subscribe.error`
  Tags: `dev`, `op`.
- `puback.missed`
  Tags: `dev`, `op`.
- `subscribe.received`
  Tags: `dev`, `op`.
- `disconnect.received`
  Tags: `dev`, `op`.

**EMQ Session metrics** category

- `created`
  Tags: `dev`, `op`.
- `terminated`
  Tags: `dev`, `op`.
- `takeovered`
  Tags: `dev`, `op`.
- `resumed`
  Tags: `dev`, `op`.
- `discarded`
  Tags: `dev`, `op`.
