## phoenix plugin

### Description

The `phoenix liveview` plugin reports metrics from requests performed to the endpoints
defined in the `phoenix` application. The plugin exposes fine-grain metrics to
give insight into your Phoenix LiveView callback requests. The plugin captures the number of
requests and the average response time for each registered callback and live component event.

The `phoenix_liveview_requests` plugin is reporting top 30 requests endpoints with 
a detailed insight into callback parameters. Callback requests will be displayed by Latency, from
high to low.

### Applications it depends on

`phoenix` and `telemetry`

The plugin only works with Phoenix versions 1.4.x.

### Modules

`wombat_plugin_phoenix_liveview_requests`
`wombat_plugin_liveview_callbacks_metrics`

### Reports

#### Metrics reported

**LiveView Callback Events** category: these metrics show the number of all callback
requests and requests performed

- `LiveView Callbacks` Number and Avrage Letency Number of liveview callbacks
  Tags: `dev`, `op`.

![LiveView Callback Events Metric](../images/liveviewmetric.png)

**LiveView Requests Table** category: shows top 30 callback requests.

- `Name` Route name, or if callback event is performend on the live component, `live_component_event` will be displayed
- `Callback` LiveView callback name
- `Event` name of the liveview callback event, for the rest of the callbacks we display `generic event`
- `MetaData` overview of the callback parameter
- `Latency` - request latency in millisecond

![LiveView Requests Table](../images/liveviewrequesttable.png)
