## riak_core plugin

### Description

The `riak_core` plugin report metrics and notifications from `riak_core`.
This plugin only focuses on `riak_core` metrics, so it is
possible to use it with any product using `riak_core`.


### Applications it depends on

`riak_core`

### Modules

- `wombat_plugin_riak_core`
- `wombat_plugin_riak_core_metrics`

### Reports

#### Alarms reported

**Riak Node down**

Please find the detailed alarm description in the
[Alarms documentation][alarmsdoc].

#### Notifications

- `vnode_started`
- `vnode_terminated`
- `node down`
- `node up`
- `handoff_initiated`
- `handoff_completed`
- `handoff_cancelled`
- `vnode_state_transfer_initiated`
- `vnode_state_transfer_completed`
- `command_received`
- Traced functions of Riak, which are called when executing Riak commands,
  (for example calling `riak-admin transfers`). These function calls are
  reported to WombatOAM including the actual arguments of the function call.
  Calls to the following functions are reported:

```
      riak_core_console:member_status/1
      riak_core_console:ring_status/1
      riak_core_console:print_member_status/2
      riak_core_console:stage_leave/1
      riak_core_console:stage_remove/1
      riak_core_console:stage_replace/1
      riak_core_console:stage_resize_ring/1
      riak_core_console:stage_force_replace/1
      riak_core_console:print_staged/1
      riak_core_console:commit_staged/1
      riak_core_console:clear_staged/1
      riak_core_console:transfer_limit/1
      riak_core_console:pending_claim_percentage/2
      riak_core_console:pending_nodes_and_claim_percentages/1
      riak_core_console:transfers/1
      riak_core_console:add_user/1
      riak_core_console:alter_user/1
      riak_core_console:del_user/1
      riak_core_console:add_group/1
      riak_core_console:alter_group/1
      riak_core_console:del_group/1
      riak_core_console:add_source/1
      riak_core_console:del_source/1
      riak_core_console:grant/1
      riak_core_console:revoke/1
      riak_core_console:print_users/1
      riak_core_console:print_user/1
      riak_core_console:print_sources/1
      riak_core_console:print_groups/1
      riak_core_console:print_group/1
      riak_core_console:print_grants/1
      riak_core_console:security_enable/1
      riak_core_console:security_disable/1
      riak_core_console:security_status/1
      riak_core_console:ciphers/1
      riak_core_console:stat_show/1
      riak_core_console:stat_info/1
      riak_core_console:stat_enable/1
      riak_core_console:stat_disable/1
      riak_core_console:stat_reset/1
      riak_core_console:command/1
      riak_kv_console:staged_join/1
      riak_kv_console:bucket_type_status/1
      riak_kv_console:bucket_type_activate/1
      riak_kv_console:bucket_type_create/1
      riak_kv_console:bucket_type_update/1
      riak_kv_console:bucket_type_list/1
      riak_kv_console:join/1
      riak_kv_console:leave/1
      riak_kv_console:remove/1
      riak_kv_console:down/1
      riak_kv_console:status/1
      riak_kv_console:vnode_status/1
      riak_kv_console:ringready/1
      riak_kv_console:aae_status/1
      riak_kv_console:ensemble_status/1
      riak_kv_console:repair_2i/1
      riak_kv_console:cluster_info/1
      riak_kv_console:reload_code/1
      riak_kv_console:reip/1
      riak_kv_console:reformat_indexes/1
      riak_kv_console:reformat_objects/1
      yz_console:aae_status/1
      yz_console:switch_to_new_search/1
      riak_core_cluster_cli:register_cli/0
      riak_core_cluster_cli:status/2
      riak_core_cluster_cli:partition_count/2
      riak_core_cluster_cli:partitions/2
      riak_core_cluster_cli:partition/2
      riak_core_handoff_cli:register_cli/0
      riak_core_handoff_cli:set_transfer_limit/3
      riak_core_handoff_cli:set_transfer_limit/5
```

#### Metrics reported

- `Vnode count (total)`
  Tags: `dev`, `op`

- `Vnode count (primary)`
  Tags: `dev`, `op`

- `Vnode count (secondary)`
  Tags: `dev`, `op`

- `Member count (total)`
  Tags: `dev`, `op`

- `Member count (active)`
  Tags: `dev`, `op`

- `Member count (down)`
  Tags: `dev`, `op`

- `Member count (joining)`
  Tags: `dev`, `op`

- `Member count (leaving)`
  Tags: `dev`, `op`

- `Member count (unreachable)`
  Tags: `dev`, `op`

- `Active handoff count (inbound)`
  Tags: `dev`, `op`


### Configuration options

None.

[alarmsdoc]: ../alarms.md#riak-node-down
<!--
    ### Usage
    #### Resource use
    (Estimate on the resource use)
    #### Stopping monitoring
    (Consequences of switching off the plugin; what will stop working in WombatOAM)
-->
