## riak_repl plugin

### Description

The `riak_repl` plugin monitors information from the
Multi-Datacenter Replication subsystem in Riak.

It can give an overview of the current status of the realtime queue,
which can give indications that a full sync might be needed.

During fullsync it is possible to see the progress and information
on previous fullsyncs.


### Applications it depends on

`riak_repl`

### Modules

- `wombat_plugin_riak_repl`
- `wombat_plugin_riak_repl_metrics`

### Reports

The plugin reports the metrics listed below.

- `Realtime queue percent used`
  Tags: `dev`, `op`

- `Realtime queue bytes used`
  Tags: `dev`, `op`

- `Realtime queue overload drops`
  Tags: `dev`, `op`

- `Realtime sent kbps`
  Tags: `dev`, `op`

- `Realtime recv kbps`
  Tags: `dev`, `op`

- `Fullsync sent kbps`
  Tags: `dev`, `op`

- `Fullsync recv kbps`
  Tags: `dev`, `op`


Counters per inter-cluster connection:

- `Busy nodes`
  Tags: `dev`, `op`

- `Fullsyncs completed`
  Tags: `dev`

- `Last fullsync duration`
  Tags: `dev`

Counters per partition state:

- `Queued partitions`
  Tags: `dev`

- `Successful exit partitions`: When this reaches ring_size the fullsync is finished.
  Tags: `dev`

- `Starting partitions`
  Tags: `dev`

- `Partitions in progress`
  Tags: `dev`

- `Partitions waiting for retry`
  Tags: `dev`

- `Error exits partitions`
  Tags: `dev`, `op`

- `Retry exits partitions`
  Tags: `dev`, `op`

- `Soft retry exits partitions`
  Tags: `dev`, `op`


### Configuration options

None.

<!--
### Usage

#### Resource use

(Estimate on the resource use)

#### Stopping monitoring

(Consequences of switching off the plugin; what will stop working in WombatOAM)
-->
