## SumoDB plugin

### Description

The plugin provides info about the performance of SumoDB. Metrics is extracted
by subscribing to SumoDB events. This plugin also provides a service showing the
data stored for a given model.

### Applications it depends on

`sumo_db`

The plugin only works with SumoDB versions 0.7.1 and above.

### Modules

`wombat_plugin_sumo_db`

### Metrics reported

The plugin provides the following 11 metrics for each model defined in SumoDB,
i.e., for each entry listed in the `docs` environment variable of the `sumo_db`
application:

- `schema_created`
  Count of schema creation. Actually, the time graph shows a single event at
  the time of schema creation if it happens during the measurement.
- `Avg time schema_created`
  Duration of schema creation.
- `persisted`
  Number of persisted entities (`sumo:persist/2`).
- `Avg time persisted`
  Average duration of persisting entities (`create` or `update`).
- `deleted`
  Number of deleted entities (`sumo:delete/2`).
- `Avg time deleted`
  Average duration of deleting entities.
- `deleted_all`
  Number of `sumo:delete_all/1` calls.
- `Avg time deleted_all`
  Average duration of `delete_all` calls.
- `deleted_total`
  Number of `sumo:delete_by/2` calls.
- `Avg time deleted_total`
  Average duration of `delete_by` calls.
- `count`
  Number of entities stored for the model.

### Service

The plugin also provides a Service that displays the current data for a
particular model in a grid or table view.
