## trails plugin

### Description

The `trails` plugin reports metrics from requests performed to the endpoints
defined in the `trails` application. When the plugin starts, it processes all
registered routes and creates a metric combining each route with every single
HTTP method (i.e. `GET`, `POST`, `PUT`). Additionally metrics for
each type of response status code is also created (i.e. `100`, `200`, `300`,
`400` and `500`).

### Applications it depends on

`trails`

The plugin requires version 0.2 or newer. Also `trails` depends on `cowboy` and
only works with `cowboy` version 1.x.

### Modules

`wombat_plugin_trails`, `wombat_plugin_cowboy_common`

### Reports

#### Metrics reported

**Cowboy-trails Request Count** category: these metrics show the number of requests
performed with a certain HTTP code or with a certain method and endpoint.

- `HTTP 1xx`
  Tags : `dev`

- `HTTP 2xx`
  Tags: `dev`, `op`

- `HTTP 3xx`
  Tags: `dev`

- `HTTP 4xx`
  Tags: `dev`, `op`

- `HTTP 5xx`
  Tags: `dev`, `op`

- `[HTTP-METHOD] /ROUTE`
  Tags: `dev`

Where `HTTP-METHOD` is one of `GET`, `POST`, `PUT` or `DELETE`; and `ROUTE` is one of
the routes defined through Cowboy Trails.

**Cowboy-trails Response Time [ms]** category: these metrics show the average response
time performed with a certain method and endpoint.

- `Avg. [HTTP-METHOD] /ROUTE`
  Tags: `dev`

Where `HTTP-METHOD` is one of `GET`, `POST`, `PUT` or `DELETE`; and `ROUTE` is one of
the routes defined through Cowboy Trails.
